import javax.microedition.lcdui.*;

/**
@@ړIuWFNg̐eNXB
	SĂ̈ړIuWFNg͂pB
@@@author Rilassaru
*/
public class BaseObj {
	// CLDCACOS/ASINKv

	/** C̍ŏP */
	static final int DGREE_RESOLUSION = 5;
	/** SINe[u */
	static final int[] SIN = {
						    0, -9,-17,-26,-34,-42,-50,-57,-64,-71,-77,-82,-87,-91,-94,-97,-98,-100,
						 -100,-100,-98,-97,-94,-91,-87,-82,-77,-71,-64,-57,-50,-42,-34,-26,-17, -9,
						    0,  9, 17, 26, 34, 42, 50, 57, 64, 71, 77, 82, 87, 91, 94, 97, 98,100,
						  100,100, 98, 97, 94, 91, 87, 82, 77, 71, 64, 57, 50, 42, 34, 26, 17,  9,
						  0
						};


	/** COSe[u */
	static final int[] COS = {
							100,100, 98, 97, 94, 91, 87, 82, 77, 71, 64, 57, 50, 42, 34, 26, 17,  9,
							  0,  -9,-17,-26,-34,-42,-50,-57,-64,-71,-77,-82,-87,-91,-94,-97,-98,-100,
						   -100,-100,-98,-97,-94,-91,-87,-82,-77,-71,-64,-57,-50,-42,-34,-26,-17, -9,
						      0,   9, 17, 26, 34, 42, 50, 57, 64, 71, 77, 82, 87, 91, 94, 97, 98,100,
							100
						};


	/** ANeBu */
	static final int STATE_NON_ACTIVE	= 0;
	/** ANeBu */
	static final int STATE_ACTIVE		= 1;
	/** Debris̓ */
	static final int STATE_EENTRY		= 2;
	
	/** Xʒu */
	long x;
	/** Yʒu */
	long y;
	/**  */
	int dir;
	/** ړx */
	int speed;
	/**  */
	int state;
	/** 蔻̑傫 */
	int size;
	
	//* -------------------------------------------------------- */
	/**
	RXgN^
	*/
	public BaseObj() {
		x = 0;
		y = 0;
		dir = 0;	// degree 0->360
		speed = 0;
		state = STATE_NON_ACTIVE;
	}
	
	//* -------------------------------------------------------- */
	/**
	yѐK
	@param	ix		XW
	@param	iy		YW
	@param	idir	
	@param	ispeed	x
	@param	isize	TCY
	*/
	public void init( int ix, int iy, int idir, int ispeed, int isize )	{
		state = STATE_ACTIVE;
		if( ix < 0 || ix > applet.SCREEN_DX )	x = 0;	else x = ix * applet.MAGNIFI;
		if( iy < 0 || iy > applet.SCREEN_DY )	y = 0;	else y = iy * applet.MAGNIFI;

		dir = (idir % 360);
		if( dir < 0 ) {
			dir = 360 + dir;
		}

		speed = ispeed;
		size = isize;
	}

	//* -------------------------------------------------------- */
	/** Xʒu擾 */
	public int getx()		{ return (int)(x / applet.MAGNIFI); }
	/** Yʒu擾 */
	public int gety()		{ return (int)(y / applet.MAGNIFI); }
	/** x擾 */
	public int getspeed()	{ return speed; }
	/** 擾 */
	public int getdir()		{ return dir; }
	
	//* -------------------------------------------------------- */
	/**
	IuWFNg̉]
	@param	degree	(+360`-360x)
	*/
	public int rotate( int degree )	{
		dir += degree;
		dir %= 360;
		dir -= (dir % DGREE_RESOLUSION);	// \Ŋ
		
		if( dir < 0 ) {
			dir = 360 + dir;
		}

		return dir;
	}
	
	//* -------------------------------------------------------- */
	/**
	ʒu̐ݒ
	@param	ix	XW
	@param	iy	YW
	*/
	public void setxy( int ix, int iy ) {
		x = ix * applet.MAGNIFI;
		y = iy * applet.MAGNIFI;
	}

	//* -------------------------------------------------------- */
	/**
	蔻
	@param	dst	ΏۃIuWFNg
	@return	茋
	*/
	public boolean hittest( BaseObj dst ) {

		long dx = (x / applet.MAGNIFI) - (dst.x / applet.MAGNIFI);
		long dy = (y / applet.MAGNIFI) - (dst.y / applet.MAGNIFI);
		long dist = size + dst.size;

		if( dx*dx + dy*dy < dist*dist )
			return true;
		else
			return false;
		
	}
	
	//* -------------------------------------------------------- */
	/**
	
	@param	dstx	ΏXʒu
	@param	dsty	ΏYʒu
	@return			
	*/
	public int distanceto( int dstx, int dsty ) {
		int srcx =  (int)( x / applet.MAGNIFI );
		int srcy =  (int)( y / applet.MAGNIFI );
		int dx = Math.abs( dstx - srcx );
		int dy = Math.abs( dsty - srcy );
		return (int)Math.sqrt( dx*dx + dy*dy );
	}

	//* -------------------------------------------------------- */
	/**
	
	@param	dstx	ΏXʒu
	@param	dsty	ΏYʒu
	@return			p
	*/
	public int dirto( int dstx, int dsty ) {
		int distance = distanceto( dstx, dsty );
		int srcx =  (int)(x / applet.MAGNIFI);
		int srcy =  (int)(y / applet.MAGNIFI);
		int dx = dstx - srcx;
		int cos;
		int ii;
		
		if( 0 == distance )
			return 0;

		cos = dx * 100 / distance;
		
		if( distance <= dx ) { // cos0/180 exception
			if( dx > 0 )
				return 0;
			else
				return 180;
		}
		
		if( srcy > dsty ) {
			for( ii = 0; ii < (180/DGREE_RESOLUSION); ii++ ) {
				if( COS[ii] <= cos ) {
					break;
				}
			}
		} else {
			for( ii = (360/DGREE_RESOLUSION)-1; ii >= (180/DGREE_RESOLUSION); ii-- ) {
				if( COS[ii] <= cos ) {
					break;
				}
			}
		}
		
		return ii * DGREE_RESOLUSION;
		
	}
	
	//* -------------------------------------------------------- */
	/**
	莞
	@param	elapsed	oߎ(msec)
	*/
	public void proceed(long elapsed) {

		if( STATE_NON_ACTIVE == state ) {
			return;
		}
		
		x += ( (COS[dir/DGREE_RESOLUSION] * speed * elapsed) / 1000 );
		y += ( (SIN[dir/DGREE_RESOLUSION] * speed * elapsed) / 1000 );
		
		if( x < 0 ) {
			x = 0;
			rotate( 180 - (dir * 2) );
		} else if( applet.SCREEN_DX * applet.MAGNIFI < x ) {
			x = applet.SCREEN_DX * applet.MAGNIFI;
			rotate( 180 - (dir * 2) );
		}

		if( y < 0 ) {
			y = 0;
			rotate( dir * -2 );
		} else if( ( applet.SCREEN_DY ) * applet.MAGNIFI < y ) {
			y = ( applet.SCREEN_DY ) * applet.MAGNIFI;
			rotate( dir * -2 );
		}
	}
}
