import javax.microedition.lcdui.*;

/**
	eۃXg
@@@author Rilassaru
*/
public class Bullets {
	static final int MAXNUM = 50;
	static final int SPEED = 100;
	
	Bullet[] b = new Bullet[MAXNUM];

	//* -------------------------------------------------------- */
	/**
		RXgN^
	*/
	Bullets() {
		int ii;

		for( ii = 0; ii < MAXNUM; ii++ ) {
			b[ii] = new Bullet();
			b[ii].state = BaseObj.STATE_NON_ACTIVE;
		}
	}
	
	//* -------------------------------------------------------- */
	/**
		Xg̏
	*/
	public void init() {
		int ii;

		for( ii = 0; ii < MAXNUM; ii++ ) {
			b[ii].state = BaseObj.STATE_NON_ACTIVE;
		}
	}

	//* -------------------------------------------------------- */
	/**
		eǉ
		@param	ix		JnXʒu 
		@param	iy		JnYʒu
		@param	idir	p
	*/
	public int add(int ix, int iy, int idir) {
		idir %= 360;
		if( idir < 0 ) {
			idir = 360 - idir;
		}
		
		//* ----------------------------------------------------- */
		int ii;

		for( ii = 0; ii < MAXNUM; ii++ ) {
			if( BaseObj.STATE_NON_ACTIVE == b[ii].state ) {
				break;
			}
		}
		
		if( MAXNUM == ii ) {
			return -1;
		}
	
		//* ----------------------------------------------------- */
		// Ship菭Oɏo
		int xhead = (int)(ix + (Bullet.COS[idir/Bullet.DGREE_RESOLUSION] * Ship.SIZE_SHIP * 50 / 1000) );
		int yhead = (int)(iy + (Bullet.SIN[idir/Bullet.DGREE_RESOLUSION] * Ship.SIZE_SHIP * 50 / 1000) );

		b[ii].init( xhead, yhead, idir, SPEED );	
		
		return ii;
	}

	//* -------------------------------------------------------- */
	/**
	莞
	@param	elapsed	oߎ(msec)
	*/
	public void proceed( long elapsed ) {
		int ii;

		for( ii = 0; ii < MAXNUM; ii++ ) {
			if( BaseObj.STATE_NON_ACTIVE !=b[ii].state ) {
				b[ii].proceed( elapsed );
			}
		}
	}
	
	//* -------------------------------------------------------- */
	/**
		`揈
		@param g	`ΏGraphicsNX
	*/
	public void paint( Graphics g ) {
		int ii;

		g.setColor( 255,255,255 );
		
		for( ii = 0; ii < MAXNUM; ii++ ) {
			if( BaseObj.STATE_NON_ACTIVE !=b[ii].state ) {
				b[ii].paint( g );
			}
		}
	}

	//* -------------------------------------------------------- */
	/**
		蔻
		@param dst	ΏۃIuWFNg
		@return		茋
	*/
	public boolean hittest( Ship dst ) {
		if( BaseObj.STATE_ACTIVE != dst.state ) {
			return false;
		}
		
		int ii;

		for( ii = 0; ii < MAXNUM; ii++ ) {
			
			if( BaseObj.STATE_ACTIVE == b[ii].state) {
				
				if( true == b[ii].hittest( dst ) ) {
					b[ii].state = BaseObj.STATE_NON_ACTIVE;
					SpaceCanv.smokes.addRed( b[ii].getx(), b[ii].gety() );
					return true;
				}
			}
		}
		return false;
	}
	
}

