import javax.microedition.lcdui.*;

/**
	fuNX
@@@author Rilassaru
*/
public class Deb extends BaseObj {
	static final int TYPE_NULL = 0;
	static final int TYPE_N = 1;
	static final int TYPE_A = 2;
	static final int TYPE_B = 3;
	static final int TYPE_C = 4;
	static final int TYPE_D = 5;
	static final int TYPE_E = 6;
	static final int TYPE_F = 7;
	static final int TYPE_END = 7;

	/** fûP܂̃TCY */
	static final int DEFAULT_RECT_SIZE = 10;
	/** ꎞ(2b) */
	static final int ENTRY_TIMER = 2000;
	static Ship target;
	int type;
	int life_time;

	//* -------------------------------------------------------- */
	/**
	RXgN^
	@param	t	`Ώ
	*/
	public Deb(Ship t) {
		target = t;
		life_time = 0;
		type = TYPE_NULL;
		state = STATE_NON_ACTIVE;
		size = 0;
	}

	//* -------------------------------------------------------- */
	/**
	
	@param	ix		JnXʒu
	@param	iy		JnYʒu
	@param	idir	Jnp
	@param	ispeed	x
	@param	itype	fu^Cv
	*/
	public void init( int ix, int iy, int idir, int ispeed, int itype ) {
		int s;
		type = itype;
		life_time = 0;
		
		switch(type) {
		case TYPE_N:
		case TYPE_A:
		case TYPE_B:
		case TYPE_D:
		case TYPE_E:
		case TYPE_F:
			s = (DEFAULT_RECT_SIZE * 15) / 10;
			break;
			
		case TYPE_C:
		default:
			s = DEFAULT_RECT_SIZE;
			break;
		}
		super.init(ix, iy, idir, ispeed, s);
		state = STATE_EENTRY;
	}

	//* -------------------------------------------------------- */
	/**
	莞
	@param	elapsed	oߎ
	*/
	public void proceed(long elapsed) {

		life_time += elapsed;

		if( STATE_EENTRY == state ) { /*  */
	
			if( life_time < ENTRY_TIMER ) {
				return;
			}
			state = STATE_ACTIVE;
		}
		
		int targetdir = dirto( target.getx(), target.gety() );		
		int mybackdir = ( dir + 180 ) % 360;

		// p̌
		switch(type) {

		//* ---------------------------------------------------- */
		case TYPE_NULL:
			return;
			
		//* ---------------------------------------------------- */
		case TYPE_N:	// ǔ^
			if( ((targetdir > dir ) && (targetdir - dir < 180))||
				((targetdir < dir ) && (dir - targetdir > 180)) ) {
				rotate(2);
			} else {
				rotate(-2);
			}
			break;

		//* ---------------------------------------------------- */
		case TYPE_A:	// `Cǔ^
		{
			if( ((targetdir > dir ) && (targetdir - dir < 180))||
				((targetdir < dir ) && (dir - targetdir > 180)) ) {
				rotate(-1);
			} else {
				rotate(1);
			}
			break;
		}
	
		//* ---------------------------------------------------- */
		case TYPE_B:	// ύX
		{
			dir = targetdir;
			break;
		}

		//* ---------------------------------------------------- */
		case TYPE_C:
		{
			break;
		}

		//* ---------------------------------------------------- */
		case TYPE_D:
		case TYPE_E:
		{
			if( ((targetdir > dir ) && (targetdir - dir < 180))||
				((targetdir < dir ) && (dir - targetdir > 180)) ) {
				rotate(5);
			} else {
				rotate(-5);
			}
			break;
		}
		
		//* ---------------------------------------------------- */
		case TYPE_F:
		{
			if( ((targetdir > dir ) && (targetdir - dir < 180))||
				((targetdir < dir ) && (dir - targetdir > 180)) ) {
				rotate(-10);
			} else {
				rotate(10);
			}
			break;
		}

		//* ---------------------------------------------------- */
		default:
			break;
		}

		super.proceed(elapsed);
	}

	//* -------------------------------------------------------- */
	/**
	`揈
	@param	g		`IuWFNg
	@param	bGray	DF`(ꎞ)ۂ
	*/
	public void paint(Graphics g, boolean bGray) {
		int xx = getx();
		int yy = gety();
		int rr, gg, bb;
		
		// ړ
		int targetdir = dirto(target.getx(), target.gety());		
		rr = 128;	gg = 128;	bb = 128;

		if( bGray ) {
			xx -= 2;
			yy += 3;
		}


		switch(type) {
		case TYPE_NULL:
			return;
		
		//* ---------------------------------------------------- */
		case TYPE_N:
		{

			if( !bGray ) {
				rr = 255;	gg = 255;	bb = 0;
			}
			
			int nSize = DEFAULT_RECT_SIZE / 2;
				
			paintRect( g, xx - nSize, yy + nSize, rr, gg, bb );
			paintRect( g, xx - nSize, yy - nSize, rr, gg, bb );
			paintRect( g, xx + nSize, yy + nSize, rr, gg, bb );
			paintRect( g, xx + nSize, yy - nSize, rr, gg, bb );
			break;
		}
				
		//* ---------------------------------------------------- */
		case TYPE_A:
		{
			if( !bGray ) {
				rr = 255;	gg = 165;	bb = 0;
			}

			paintRect( g, xx, yy, rr, gg, bb );
			int rotate = 360 - ((life_time/10)%360);

			int tmpx, tmpy;
			int tmpdir1 = ((rotate+135) % 360) / DGREE_RESOLUSION;
			int tmpdir2 = ((rotate+ 90) % 360) / DGREE_RESOLUSION;
			int tmpdir3 = ((rotate+270) % 360) / DGREE_RESOLUSION;

			tmpx = xx + (( COS[tmpdir1] * DEFAULT_RECT_SIZE ) / 71);
			tmpy = yy + (( SIN[tmpdir1] * DEFAULT_RECT_SIZE ) / 71);
			paintRect( g, tmpx, tmpy, rr, gg, bb );

			tmpx = xx + (( COS[tmpdir2] * DEFAULT_RECT_SIZE ) / 100);
			tmpy = yy + (( SIN[tmpdir2] * DEFAULT_RECT_SIZE ) / 100);
			paintRect( g, tmpx, tmpy, rr, gg, bb );

			tmpx = xx + (( COS[tmpdir3] * DEFAULT_RECT_SIZE ) / 100);
			tmpy = yy + (( SIN[tmpdir3] * DEFAULT_RECT_SIZE ) / 100);

			paintRect( g, tmpx, tmpy, rr, gg, bb );
			break;
		}

		//* ---------------------------------------------------- */
		case TYPE_B:
		{
			if( !bGray ) {
				rr = 64;		gg = 64;		bb = 255;
			}

			paintRect( g, xx, yy, rr, gg, bb );
			int rotate = life_time/10;

			int tmpx, tmpy;
			int tmpdir1 = ((rotate+ 45) % 360) / DGREE_RESOLUSION;
			int tmpdir2 = ((rotate+ 90) % 360) / DGREE_RESOLUSION;
			int tmpdir3 = ((rotate+270) % 360) / DGREE_RESOLUSION;

			tmpx = xx + (( COS[tmpdir1] * DEFAULT_RECT_SIZE ) / 71);
			tmpy = yy + (( SIN[tmpdir1] * DEFAULT_RECT_SIZE ) / 71);
			paintRect( g, tmpx, tmpy, rr, gg, bb );

			tmpx = xx + (( COS[tmpdir2] * DEFAULT_RECT_SIZE ) / 100);
			tmpy = yy + (( SIN[tmpdir2] * DEFAULT_RECT_SIZE ) / 100);
			paintRect( g, tmpx, tmpy, rr, gg, bb );

			tmpx = xx + (( COS[tmpdir3] * DEFAULT_RECT_SIZE ) / 100);
			tmpy = yy + (( SIN[tmpdir3] * DEFAULT_RECT_SIZE ) / 100);

			paintRect( g, tmpx, tmpy, rr, gg, bb );
			break;
		}

		//* ---------------------------------------------------- */
		case TYPE_C:
		{
			if( !bGray ) {
				rr = 0;		gg = 255;		bb = 255;
			}

			paintRect( g, xx, yy, rr, gg, bb );
			break;
		}
		
		//* ---------------------------------------------------- */
		case TYPE_D:
		{
			if( !bGray ) {
				rr = 200;		gg = 0;		bb = 128;
			}

			paintRect( g, xx, yy, rr, gg, bb );

			int tmpx, tmpy;
			int tmpdir1 = ((targetdir+  0) % 360) / DGREE_RESOLUSION;
			int tmpdir2 = ((targetdir+ 90) % 360) / DGREE_RESOLUSION;
			int tmpdir3 = ((targetdir+270) % 360) / DGREE_RESOLUSION;

			tmpx = xx + (( COS[tmpdir1] * DEFAULT_RECT_SIZE ) / 100);
			tmpy = yy + (( SIN[tmpdir1] * DEFAULT_RECT_SIZE ) / 100);
			paintRect( g, tmpx, tmpy, rr, gg, bb );

			tmpx = xx + (( COS[tmpdir2] * DEFAULT_RECT_SIZE ) / 100);
			tmpy = yy + (( SIN[tmpdir2] * DEFAULT_RECT_SIZE ) / 100);
			paintRect( g, tmpx, tmpy, rr, gg, bb );

			tmpx = xx + (( COS[tmpdir3] * DEFAULT_RECT_SIZE ) / 100);
			tmpy = yy + (( SIN[tmpdir3] * DEFAULT_RECT_SIZE ) / 100);

			paintRect( g, tmpx, tmpy, rr, gg, bb );
			break;
		}

		//* ---------------------------------------------------- */
		case TYPE_E:
		{
			if( !bGray ) {
				rr = 255;		gg = 0;		bb = 0;
			}

			paintRect( g, xx, yy, rr, gg, bb );
			int rotate = life_time / 5;

			int tmpx, tmpy;
			int tmpdir1 = ((rotate+ 135 ) % 360) / DGREE_RESOLUSION;
			int tmpdir2 = ((rotate+  90 ) % 360) / DGREE_RESOLUSION;
			int tmpdir3 = ((rotate+   0 ) % 360) / DGREE_RESOLUSION;

			tmpx = xx + (( COS[tmpdir1] * DEFAULT_RECT_SIZE ) / 71);
			tmpy = yy + (( SIN[tmpdir1] * DEFAULT_RECT_SIZE ) / 71);
			paintRect( g, tmpx, tmpy, rr, gg, bb );

			tmpx = xx + (( COS[tmpdir2] * DEFAULT_RECT_SIZE ) / 100);
			tmpy = yy + (( SIN[tmpdir2] * DEFAULT_RECT_SIZE ) / 100);
			paintRect( g, tmpx, tmpy, rr, gg, bb );

			tmpx = xx + (( COS[tmpdir3] * DEFAULT_RECT_SIZE ) / 100);
			tmpy = yy + (( SIN[tmpdir3] * DEFAULT_RECT_SIZE ) / 100);

			paintRect( g, tmpx, tmpy, rr, gg, bb );
			break;
		}
		
		//* ---------------------------------------------------- */
		case TYPE_F:	//
		{
			if( !bGray ) {
				rr = 0;		gg = 255;		bb = 0;
			}

			paintRect( g, xx, yy, rr, gg, bb );
			int rotate = life_time / 2;

			int tmpx, tmpy;
			int tmpdir1 = ((rotate+  45 ) % 360) / DGREE_RESOLUSION;
			int tmpdir2 = ((rotate+  90 ) % 360) / DGREE_RESOLUSION;
			int tmpdir3 = ((rotate+ 180 ) % 360) / DGREE_RESOLUSION;

			tmpx = xx + (( COS[tmpdir1] * DEFAULT_RECT_SIZE ) / 71);
			tmpy = yy + (( SIN[tmpdir1] * DEFAULT_RECT_SIZE ) / 71);
			paintRect( g, tmpx, tmpy, rr, gg, bb );

			tmpx = xx + (( COS[tmpdir2] * DEFAULT_RECT_SIZE ) / 100);
			tmpy = yy + (( SIN[tmpdir2] * DEFAULT_RECT_SIZE ) / 100);
			paintRect( g, tmpx, tmpy, rr, gg, bb );

			tmpx = xx + (( COS[tmpdir3] * DEFAULT_RECT_SIZE ) / 100);
			tmpy = yy + (( SIN[tmpdir3] * DEFAULT_RECT_SIZE ) / 100);

			paintRect( g, tmpx, tmpy, rr, gg, bb );
			break;
		}

		//* ---------------------------------------------------- */
		default:
			break;
		}
	}
	
	//* -------------------------------------------------------- */
	private void paintRect(Graphics g, int ix, int iy, int ir, int ig, int ib) {
		int xx = ix - (DEFAULT_RECT_SIZE / 2 );
		int yy = iy - (DEFAULT_RECT_SIZE / 2 );

		g.setColor( ir, ig, ib );
		g.fillRect( xx, yy, DEFAULT_RECT_SIZE, DEFAULT_RECT_SIZE );

		g.setColor( 128,128,128 );
		g.drawRect( xx, yy, DEFAULT_RECT_SIZE, DEFAULT_RECT_SIZE );
	}
}

