import javax.microedition.lcdui.*;

/**
	@NX
@@@author Rilassaru
*/
public class Ship extends BaseObj {

	static final int SIZE_SHIP = 2;
	static final int WINGSIZE = 8;
	static final int MAX_POWER = 100;
	
	int power;

	//* -------------------------------------------------------- */
	/**
	RXgN^
	*/
	Ship() {
	}
	
	//* -------------------------------------------------------- */
	/**
	
	@param	ix	JnXʒu
	@param	iy	JnYʒu
	*/
	public void	init( int ix, int iy ) {
		super.init( ix, iy, 135, 70, SIZE_SHIP );
		power = MAX_POWER;
	}

	//* -------------------------------------------------------- */
	/**
	̗͌
	@param	percent	Z
	@return	Z
	*/
	public int reducePower(int percent) {
		power -= ( (MAX_POWER * percent) / 100 );
		if( power < 0 )
			power = 0;
		return power;
	}

	//* -------------------------------------------------------- */
	/**
	c̗͂ɂĎ@̐Fω(gp)
	@param	g	`ΏۃIuWFNg
	*/
	public void setColorByShipPower( Graphics g ) {
		int bb = (255 * power / MAX_POWER);
		int rr = 255 - bb;
		g.setColor( rr, 0, bb );
	}

	//* -------------------------------------------------------- */
	/**
	`揈
	@param	g	`ΏۃIuWFNg
	*/
	public void paint( Graphics g ) {
		if( state != BaseObj.STATE_ACTIVE ) {
			return;
		}
		int hdir = dir / DGREE_RESOLUSION;
		int ldir = (dir + 140) % 360 / DGREE_RESOLUSION;
		int rdir = (dir + 220) % 360 / DGREE_RESOLUSION;

		int xx = (int)( x / applet.MAGNIFI );
		int yy = (int)( y / applet.MAGNIFI );
		int xhead, yhead, xlwing, ylwing, xrwing, yrwing;

		try {		
			xhead  = ( xx + (COS[hdir] * WINGSIZE ) / 100 );
			yhead  = ( yy + (SIN[hdir] * WINGSIZE ) / 100 );
			xlwing = ( xx + (COS[ldir] * WINGSIZE ) / 100 );
			ylwing = ( yy + (SIN[ldir] * WINGSIZE ) / 100 );
			xrwing = ( xx + (COS[rdir] * WINGSIZE ) / 100 );
			yrwing = ( yy + (SIN[rdir] * WINGSIZE ) / 100 );

			setColorByShipPower( g );
			g.fillTriangle( xhead, yhead, xlwing, ylwing, xrwing, yrwing );
			
			g.setColor( 128, 128, 128 );
			g.drawLine( xhead,  yhead,  xlwing, ylwing );
			g.drawLine( xlwing, ylwing, xrwing, yrwing );
			g.drawLine( xhead,  yhead,  xrwing, yrwing );
		} catch(Exception e) {
			System.out.println( "h:"+hdir+" l:"+ldir+" r:"+rdir );
		}
	}
}

