import javax.microedition.lcdui.*;

/**
	Title f[^i[NX
@@@author Rilassaru
*/
class Title {
	int counter = 0;
	static final int DEFAULT_RECT_SIZE = 10;
	static final int[][] title = {
{0,0,1},{1,0,1},          {4,0,2},{5,0,2},  {7,0,3},{8,0,3},          {11,0,4},           {14,0,5},  {16,0,6},{17,0,6},{18,0,6},
{0,1,1},        {2,1,1},  {4,1,2},          {7,1,3},        {9,1,3},  {11,1,4},           {14,1,5},  {16,1,6},         {18,1,6},
{0,2,1},        {2,2,1},  {4,2,2},          {7,2,3},        {9,2,3},  {11,2,4},           {14,2,5},  {16,2,6},
{0,3,1},        {2,3,1},  {4,3,2},          {7,3,3},        {9,3,3},  {11,3,4},           {14,3,5},  {16,3,6},
{0,4,1},        {2,4,1},  {4,4,2},{5,4,2},  {7,4,3},{8,4,3},          {11,4,4},           {14,4,5},           {17,4,6},
{0,5,1},        {2,5,1},  {4,5,2},          {7,5,3},        {9,5,3},  {11,5,4},           {14,5,5},                    {18,5,6},
{0,6,1},        {2,6,1},  {4,6,2},          {7,6,3},        {9,6,3},  {11,6,4},           {14,6,5},                    {18,6,6},
{0,7,1},        {2,7,1},  {4,7,2},          {7,7,3},        {9,7,3},  {11,7,4},           {14,7,5},  {16,7,6},         {18,7,6},
{0,8,1},{1,8,1},          {4,8,2},{5,8,2},  {7,8,3},{8,8,3},          {11,8,4},{12,8,4},  {14,8,5},  {16,8,6},{17,8,6},{18,8,6}
};

	//* -------------------------------------------------------- */
	/**
	
	@param	
	@return	
	*/
	Title() {}

	//* -------------------------------------------------------- */
	/**
	
	@param	
	@return	
	*/
	public void paint(Graphics g, long lDiffTime) {
		
		counter += (lDiffTime%10)+1;
		counter %= 360;
		int targetdir = counter / BaseObj.DGREE_RESOLUSION;
		
		int xx;
		int yy;
		for( int ii = 0; ii < title.length; ii++ ) {
			xx = ((title[ii][0]+2) * DEFAULT_RECT_SIZE);
			yy = ((title[ii][1]+8) * DEFAULT_RECT_SIZE);
			paintRect( g, xx, yy, title[ii][2] );
		}
	}

	/**
	
	@param	
	@return	
	*/
	private void paintRect( Graphics g, int ix, int iy, int color ) {
		int rr;
		int gg;
		int bb;
		
		switch( color ) {
			case 1:	rr=255;	gg=0;	bb=255;	break;
			case 2:	rr=0;	gg=255;	bb=0;	break;
			case 3:	rr=255;	gg=128;	bb=0;	break;
			case 4:	rr=128;	gg=0;	bb=128;	break;
			case 5:	rr=0;	gg=0;	bb=128;	break;
			case 6:	rr=255;	gg=0;	bb=128;	break;
			default:rr=255;	gg=255;	bb=128;	break;
		}

		g.setColor( rr, gg, bb );
		g.fillRect( ix, iy, DEFAULT_RECT_SIZE, DEFAULT_RECT_SIZE );
		
		g.setColor( 0, 0, 0 );
		g.drawRect( ix, iy, DEFAULT_RECT_SIZE, DEFAULT_RECT_SIZE );
	}
}