import javax.microedition.midlet.*;
import javax.microedition.lcdui.game.*;
import javax.microedition.lcdui.*;
import javax.microedition.media.*;
import javax.microedition.rms.*;
import java.io.*;

 	

/**
@@Avbg̃Gg|Cg
@@@author Rilassaru
*/
public final class applet extends MIDlet implements CommandListener {

	private static Thread thread;
	private static Command cmdExit = new Command("Exit", Command.EXIT,1);
	private static Command cmdHelp = new Command("Help", Command.HELP,1);
	private static Command cmdBack = new Command("Back", Command.BACK,1);
	private static applet instance;

	// R[hXgA̖O	
	private final String strRmsHiscore =  new String( "score" );
	private final String strRmsVolume =  new String( "volume" );
	private final String strRmsViblation =  new String( "viblation" );


	/** pʉTCY */
	public static final int SCREEN_DX = 240;
	/** pʏcTCY */
	public static final int SCREEN_DY = 296;
	/** ʊJnʒu */
	public static final int OFFSET_DX = 0;
	/** ʊJncʒu */
	public static final int OFFSET_DY = 0;

	/** tHgcTCY */
	public static final int FONTSIZE_DX		= 10;
	/** tHgTCY */
	public static final int FONTSIZE_DY		= 16;

	/** \(dpd) */
	public static final int MAGNIFI = 100;

	/** CXbh̐tO */
	public static boolean isPaused;

	/**	L[͗pXbhXbhtO */
	public static boolean bThreadLoop;

	/**	CQ[LpX */
	public static SpaceCanv canvasGame;
	/**	ݒpLoX */
	public static SettingCanv canvasSetting;

	/**	tHgi[pXvCg*/
	static Sprite sprFont16;
	/** ǎi[pXvCg */
	static Image imgWallPaper;
	/** ǎi[pXvCg */
	static Image imgMucha1;
	/** ǎi[pXvCg */
	static Image imgMucha3;
	/** Mwii[pC[W */
	static Image imgPen;
	/** Swii[pC[W */
	static Image imgEraser;

	
	// ֌W̐ݒ
	/** {[l */
	public static int volume;
	/** oCu[Vݒ */
	public static int viblation;

	/**  */
	static java.util.Random rand;

	/* ----------------------------------------------------------------------*/
	/**
	RXgN^
	*/
	public applet() {
		bThreadLoop = true;
		isPaused = false;

		rand = new java.util.Random( System.currentTimeMillis() );
		canvasGame = new SpaceCanv();
		canvasSetting = new SettingCanv();

		canvasGame.addCommand(cmdHelp);
		canvasGame.addCommand(cmdExit);
		canvasGame.setCommandListener(this);

		canvasSetting.addCommand(cmdBack);
		canvasSetting.setCommandListener(this);


		Display.getDisplay(this).setCurrent( canvasGame );

		try {
			sprFont16 = new Sprite( Image.createImage( "/font16.png" ), FONTSIZE_DX, FONTSIZE_DY );
			imgWallPaper = Image.createImage( "/bg_note.png" );
			imgMucha1	 = Image.createImage( "/mucha1.jpg" );
			imgMucha3	 = Image.createImage( "/mucha3.jpg" );
			imgPen       = Image.createImage( "/bg_pen.png" );
			imgEraser	 = Image.createImage( "/bg_eraser.png" );
		
		} catch( Exception e ) {}

		try {
			thread = new Thread(canvasGame);
			thread.start();
		} catch (Exception e) {
			System.out.println( e.toString() );
		}
	}
	/* ----------------------------------------------------------------------*/
	/**
	AvbgJn
	*/
	public void startApp() {

		System.gc();
		instance = this;
			
		canvasGame.hiscore = loadInt( strRmsHiscore, 0 );
		volume = loadInt( strRmsVolume, 50 );
		viblation = loadInt( strRmsViblation, 0 );

		canvasGame.gameResume();
	}

	/* ----------------------------------------------------------------------*/
	/**
	Avbgꎞ~
	*/
	public void pauseApp() {

		canvasGame.gamePause();
		
		saveInt( strRmsHiscore, canvasGame.hiscore );
	}

	/* ----------------------------------------------------------------------*/
	/**
	AvbgI
	*/
	public void destroyApp( boolean flag ) {
		saveInt( strRmsHiscore, canvasGame.hiscore );
		bThreadLoop = false;
		canvasGame = null;
	}

	/* ----------------------------------------------------------------------*/
	/**
	R}h
	*/
	public void commandAction( Command c, Displayable disp )
	{
		if( c == cmdExit )
		{
			try
			{
				destroyApp(false);
				notifyDestroyed();
			}
			catch( Exception e ) {}
			
		} else if( c == cmdHelp ) {

			Display.getDisplay(this).setCurrent( canvasSetting );
			canvasGame.gamePause();

			
		} else if( c == cmdBack ) {
			canvasChangeToGame();
			canvasGame.gameResume();
		}
		
	}

	/* ----------------------------------------------------------------------*/
	/**
	ݒʂQ[ʂ֑J		
	{[lƃoCu[V̐ݒlۑAʑJڂ{B
	*/
	public void canvasChangeToGame() {
		saveInt( strRmsVolume, volume );
		saveInt( strRmsViblation, viblation );
		Display.getDisplay(this).setCurrent( canvasGame );
	}
	
	/* ----------------------------------------------------------------------*/
	/**
	nCXRAWebLOo^
	JadɋLڂĂURLɃWvB
	*/
	public void webAccess() {
		try {
			String rankingurl = getAppProperty("rankingurl");
			if( null == rankingurl ) {
				platformRequest( "http://urana.info/m/" );
			} else {
				platformRequest( rankingurl+"register_score_spacedebris="+canvasGame.hiscore );
			}
		} catch (Exception e) {}
	}

	/* ----------------------------------------------------------------------*/
	/**
	lۑ
	@param strRecName	R[h
	@param value		ۑl
	*/
	public void saveInt(String strRecName, int value) {

		RecordStore rs = null;

		try {
			ByteArrayOutputStream baos = new ByteArrayOutputStream();
			DataOutputStream outputStream = new DataOutputStream(baos);

			rs = RecordStore.openRecordStore( strRecName, true );
			outputStream.writeInt(value);

			byte[] b = baos.toByteArray();

			if( 0 == rs.getNumRecords() ) {
				rs.addRecord( b, 0, b.length );
			}
			else {
				rs.setRecord( 1, b, 0, b.length );
			}

			rs.closeRecordStore();
			outputStream = null;
			baos = null;
			rs = null;

		} catch (Exception e) {}
	}

	/* ----------------------------------------------------------------------*/
	/**
	lǂݍ
	@param strRecName	R[h
	@param defaultValue	sۂ̕ԋpl
	@return 			擾l
	*/
	private int loadInt(String strRecName, int defaultValue) {
		int score = 0;
		
		RecordStore rs = null;
		try {
		
			rs = RecordStore.openRecordStore( strRecName, false );
		
			ByteArrayInputStream bais = new ByteArrayInputStream(rs.getRecord(1));
			DataInputStream inputStream = new DataInputStream(bais);
				
			score = inputStream.readInt();

			rs.closeRecordStore();
			inputStream = null;
			bais = null;
			rs = null;

			return score;

		} catch (Exception e) {}
		return defaultValue;
		
	}
	/* ----------------------------------------------------------------------*/
	/**
	100~b̃oCu[VJn
	*/
	public void startVib() {
		Display.getDisplay(this).vibrate( 100 );
	}

	/* ----------------------------------------------------------------------*/
	/**
	oCu[V~
	*/
	public void stopVib() {
		Display.getDisplay(this).vibrate( 0 );
	}

	//* -------------------------------------------------------- */
	/**
	AvbgCX^X̕ԋp
	*/
	public static applet getInstance() {
		return instance;
	}
}
