import javax.microedition.lcdui.*;

/**
	fuXgǗNX
@@@author Rilassaru
*/
public class Debs {
	static final int MAXNUM = 50;
	static final int DEFAULT_SPEED = 20;
	static Ship target;

	Deb[] b = new Deb[MAXNUM];

	//* -------------------------------------------------------- */
	/**
	RXgN^
	@param	t	@IuWFNg
	*/
	public Debs(Ship t) {
		int ii;
		target = t;

		for( ii = 0; ii < MAXNUM; ii++ ) {
			b[ii] = new Deb(t);
		}
	}

	//* -------------------------------------------------------- */
	/**
	
	*/
	public void init() {
		int ii;

		for( ii = 0; ii < MAXNUM; ii++ ) {
			b[ii].state = BaseObj.STATE_NON_ACTIVE;
		}
	}

	//* -------------------------------------------------------- */
	/**
	fuǉ
	@param	type	ǉfu
	*/
	public void add(int type) {
		
		int basex, basey;
		int ispeed = DEFAULT_SPEED;
		int vacant = getVacantNumber();

		if( vacant < 0 ) return;
		basex = Math.abs(applet.rand.nextInt() % (applet.SCREEN_DX/2) ) + (applet.SCREEN_DX/4);
		basey = Math.abs(applet.rand.nextInt() % (applet.SCREEN_DY/2) ) + (applet.SCREEN_DY/4);

		switch( type ) {

		case Deb.TYPE_N:
		{
			b[vacant].init( basex, basey, target.dir, (ispeed / 2), type );
			break;
		}

		case Deb.TYPE_A:
		{
			b[vacant].init( basex, basey, target.dir + 90, (ispeed / 2), type );
			break;
		}

		case Deb.TYPE_B:
		{
			b[vacant].init( basex, basey, target.dir + 90, ispeed, type );
			break;
		}
		case Deb.TYPE_C:
		{
			int direction = ((applet.rand.nextInt() % 4) * 90);
			
			if( 0 == (applet.rand.nextInt() % 2) ) {
				b[vacant].init(  basex-10, basey, direction, ispeed, type );
				vacant = getVacantNumber();
				
				if( vacant < 0 ) return;
				b[vacant].init(  basex+ 0, basey, direction, ispeed, type );
				vacant = getVacantNumber();
				
				if( vacant < 0 ) return;
				b[vacant].init(  basex+10, basey, direction, ispeed, type );
				vacant = getVacantNumber();
				
				if( vacant < 0 ) return;
				b[vacant].init(  basex+20, basey, direction, ispeed, type );
			} else {
				b[vacant].init(  basex, basey-10, direction, ispeed, type );
				vacant = getVacantNumber();
				
				if( vacant < 0 ) return;
				b[vacant].init(  basex, basey, direction, ispeed, type );
				vacant = getVacantNumber();
				
				if( vacant < 0 ) return;
				b[vacant].init(  basex, basey+10, direction, ispeed, type );
				vacant = getVacantNumber();
				
				if( vacant < 0 ) return;
				b[vacant].init(  basex, basey+20, direction, ispeed, type );
			}

			break;
		}

		case Deb.TYPE_D:
		{
			b[vacant].init( basex, basey, target.dir + 180, ispeed, type );
			break;
		}
		
		case Deb.TYPE_E:
		{
			b[vacant].init( basex, basey, target.dir, ispeed * 3 / 2, type );
			break;
		}

		case Deb.TYPE_F:
		{
			b[vacant].init( basex, basey, target.dir, ispeed * 2, type );
			break;
		}
		default:
			return;
		}
	}

	//* -------------------------------------------------------- */
	/**
	󂫔ԍ擾
	*/
	private int getVacantNumber() {
		int ii;

		for( ii = 0; ii < MAXNUM; ii++ ) {
			if( BaseObj.STATE_NON_ACTIVE == b[ii].state ) {
				break;
			}
		}
		
		if( MAXNUM == ii ) {
			return -1;
		}
		
		return ii;
	}

	//* -------------------------------------------------------- */
	/**
	󂫂邩ǂ
	*/
	public boolean isEmpty() {
		int ii;

		for( ii = 0; ii < MAXNUM; ii++ ) {
			if( BaseObj.STATE_ACTIVE == b[ii].state || BaseObj.STATE_EENTRY == b[ii].state ) {
				return false;
			}
		}
		return true;	
	}
	
	//* -------------------------------------------------------- */
	/**
	莞Ԋu
	@param	elapsed	oߎ(msec)
	*/
	public void proceed( long elapsed ) {
		int ii;

		for( ii = 0; ii < MAXNUM; ii++ ) {
			if( BaseObj.STATE_NON_ACTIVE != b[ii].state ) {
				b[ii].proceed( elapsed );
			}
		}
	}
	
	//* -------------------------------------------------------- */
	/**
	`揈
	@param	g	`ΏۃIuWFNg
	*/
	public void paint( Graphics g ) {
		int ii;
		
		for( ii = 0; ii < MAXNUM; ii++ ) {
			if( BaseObj.STATE_ACTIVE == b[ii].state || BaseObj.STATE_EENTRY == b[ii].state) {
				b[ii].paint( g, true );
			}

		}

		for( ii = 0; ii < MAXNUM; ii++ ) {
			if( BaseObj.STATE_ACTIVE == b[ii].state/* || BaseObj.STATE_EENTRY == b[ii].state*/) {
				b[ii].paint( g, false );
			}
		}
	}

	//* -------------------------------------------------------- */
	/**
	蔻
	@param	dst	蔻ΏۃIuWFNg
	@return	茋
	*/
	public boolean hittest( BaseObj dst ) {
		for( int ii = 0; ii < MAXNUM; ii++ ) {
			if( BaseObj.STATE_ACTIVE == b[ii].state) {
				if( true == b[ii].hittest( dst ) ) {
					b[ii].state = BaseObj.STATE_NON_ACTIVE;
					SpaceCanv.smokes.add( b[ii].getx(), b[ii].gety() );
					return true;
				}
			}
		}
		return false;
	}

	//* -------------------------------------------------------- */
	/**
	e蔻
	@param	dst	蔻ΏۃIuWFNg
	@return	茋
	*/
	public int hittest( Bullets dst ) {
		int score = 0;

		for( int ii = 0; ii < Bullets.MAXNUM; ii++ ) {
			if( BaseObj.STATE_ACTIVE == dst.b[ii].state ) {
				if( true == this.hittest( dst.b[ii] ) ) {
					dst.b[ii].state = BaseObj.STATE_NON_ACTIVE;
					score++;
				}
			}
		}
		return score;
	}
}