import javax.microedition.lcdui.*;

/**
	_
@@@author Rilassaru
*/
public class Smoke {
	/**  */
	static final int EXPLOSION_TIMER = 3000;

	/**  */
	public static final int SMOKE_NULL = 0;
	/** OCœhԂ锚_ */
	public static final int SMOKE_FILL = 1;
	/** Ԃ̔_(@蔻莞p) */
	public static final int SMOKE_RED  = 2;
	/** ̔_(@]p) */
	public static final int SMOKE_BLUE = 3;

	/** ʒuX */
	public int x;
	/** ʒuY */
	public int y;
	/** Ct^C */
	public int time;
	/** ^Cv */
	public int type;
	
	//* -------------------------------------------------------- */
	/**
	RXgN^
	*/
	Smoke() {
		time = 0;
		type = SMOKE_NULL;
	}

	//* -------------------------------------------------------- */
	/**
	
	@param	elapsed	oߎ
	*/
	public void proceed(long elapsed) {
		if( time < EXPLOSION_TIMER ) {
			time += elapsed;
			return;
		}
		
		type = SMOKE_NULL;
		time = 0;
		return;
	}

	//* -------------------------------------------------------- */
	/**
	hԂ^Cv̕`揈
	@param	g	`ΏۃIuWFNg
	*/
	public void paintFill(Graphics g) {

		if( SMOKE_FILL == type ){
			int expcolor = /*255 -*/ (( 128 * time ) / EXPLOSION_TIMER + 128 );
			int circle_size = (time / 10) % 255;
	
			if(( expcolor < 0 )||( 200 < expcolor )) {
				return;
			}
			
			g.setColor( expcolor, expcolor, expcolor );
			g.fillArc( x - (circle_size/2), y - (circle_size/2), circle_size, circle_size, 0, 360 );
			return;
		}
	}

	//* -------------------------------------------------------- */
	/**
	~^Cv̕`揈
	@param	g	`ΏۃIuWFNg
	*/
	public void paintLine(Graphics g) {
		if( SMOKE_FILL == type ) {
			int expcolor = /*255 -*/ (( 192 * time ) / EXPLOSION_TIMER + 63 );
	
			if(( expcolor < 0 )||( 255 < expcolor )) {
				return;
			}	
			
			g.setColor( expcolor, expcolor, expcolor );
			int circle_size = (time / 10) % 255;
			
			g.drawArc( x - (circle_size/2), y - (circle_size/2), circle_size, circle_size, 0, 360 );
			
		} else if( SMOKE_RED == type ) {
			int expcolor = /*255 -*/ (( 255 * time ) / EXPLOSION_TIMER );
			int circle_size = (time / 50) % 255;
	
			if( expcolor < 0 )	expcolor = 0;
			else if( 255 < expcolor ) expcolor = 255;

			g.setColor( 255, expcolor, expcolor );
			g.drawArc( x - (circle_size/2), y - (circle_size/2), circle_size, circle_size, 0, 360 );
			return;
			
		} else if( SMOKE_BLUE == type ) {
			int expcolor = /*255 -*/ (( 255 * time ) / EXPLOSION_TIMER );
			int circle_size = (time / 100) % 255;
	
			if( expcolor < 0 )	expcolor = 0;
			else if( 255 < expcolor ) expcolor = 255;
			g.setColor( expcolor, expcolor, 255 );
			g.drawArc( x - (circle_size/2), y - (circle_size/2), circle_size, circle_size, 0, 360 );
			return;
		}
	}
}
