import javax.microedition.midlet.*;
import javax.microedition.lcdui.game.*;
import javax.microedition.lcdui.*;
import javax.microedition.media.*;
import javax.microedition.media.control.*;
import java.io.*;

/**
	Q[CLoX
@@@author Rilassaru
*/
public class SpaceCanv extends GameCanvas implements Runnable {

	private final String strTitleSpace =      new String( "Space Debris" );
	private final String strTitleCIshisoft =  new String( " Rilassaru 2007" );
	private final String strTitleCRilassaru = new String( " Rilassaru 2007" );
	private final String strTitleGameStart =  new String( "Game start" );
	private final String strTitleHowToPlay =  new String( "How to play" );
	private final String strTitleHowHiScore = new String( "Hi      Sc" );

	private final String strGameOver        = new String( "Game Over" );
	private final String strGamePaused      = new String( "Paused" );
	private final String strGameToExit      = new String( "To exit, push #" );
	private final String strWebAccess       = new String( "Regist hiscore, push *" );

	private long lStageLifeTime;

	/** L[̓Xbh */
	public static Thread keyThread;
	/** L[̓XbhNX */
	KeyInput keyInput;

	/** ^Cg */
	public static final int STAGE_TITLE		= 0;
	/** Q[Jn */
	public static final int STAGE_STARTING	= 1;
	/** Q[ */
	public static final int STAGE_GAME		= 2;
	/** Q[I[o[ */
	public static final int STAGE_GAMEOVER	= 3;
	
	/** GoԊu */
	public static final int DEBS_INTERVAL	= 5000;		
	/** őXbhԊu */
	public static final int MAX_THREAD_INTERVAL = 100;	//msec

	/** ݏ */
	public int stage;
	/** nCXRA */
	public int hiscore;
	/** ݃XRA */
	public int score;
	/** fu^C}[ */
	public int debsinterval;
	/** 1btbJ */
	public boolean flip1sec;
	
	/** ǎݒ */
	private int wallpaper_flag = 0;
	
	/** `IuWFNg */
	Graphics g;

	/** @ */
	static Ship ship;
	/** fuXg */
	static Debs debs;
	/** eXg */
	static Bullets bullets;
	/** _Xg */
	static Smokes smokes;
	/** ^Cgf[^ */
	static Title title;

	/** ݂̃Q[oߎ */
	static long gameTime;

	/** BGM */
	private Player sndBGM = null;

	/** {[Rg[ */
	public VolumeControl vc = null;
	//* -------------------------------------------------------- */
	/**
	RXgN^
	*/
	SpaceCanv() {
		super(false);
		try {
			g = getGraphics();

			ship = new Ship();
			debs = new Debs(ship);
			title = new Title();
			smokes = new Smokes();
			bullets = new Bullets();
			
			keyInput = new KeyInput(this);
			keyThread = new Thread(keyInput);
			keyThread.start();
			
			// BGM̍쐬
			sndBGM = Manager.createPlayer( getClass().getResourceAsStream("bgm.mid"), "audio/midi" );
			sndBGM.prefetch();
			sndBGM.setLoopCount(-1);

			// {[Rg[̍쐬
			vc = (VolumeControl)sndBGM.getControl( "VolumeControl" );

			// {[x̐ݒ
			vc.setLevel(applet.volume);
				
			
			stageChange( STAGE_TITLE );
		} catch (Exception e) {
			applet.bThreadLoop = false;
			System.out.println( e.toString() );

			g.setColor( 0, 0, 0 );
			g.fillRect( 0, 0, getWidth(), getHeight() );
			g.setColor( 255, 255, 255 );
			g.drawString( "SpaceCanv(): "+e.toString(), 0, 0, Graphics.LEFT|Graphics.TOP);
			flushGraphics();
		}

	}
	
	//* -------------------------------------------------------- */
	/**
	L[̓R[obN
	ẼL[͂͒Ԋuœ͂100~XbhĂяoB
	*/
	public void keyInputCallback() {

		if( applet.isPaused ) {
			return;
		}

		int keyState = getKeyStates();

		if ( 0 != (keyState & LEFT_PRESSED) ) { 
			ship.rotate(10);
			smokes.addBlue( ship.getx(), ship.gety() );
		}
		else if ( 0 != (keyState & RIGHT_PRESSED) ) {
			ship.rotate(-10);
			smokes.addBlue( ship.getx(), ship.gety() );
		}
	}

	//* -------------------------------------------------------- */
	/**
	L[
	@param	keyCode	̓L[
	*/
	public void keyPressed(int keyCode) {
		
		switch( stage ) {

		case STAGE_TITLE:
		{
			if( FIRE == getGameAction( keyCode ) ) {
				stageChange( STAGE_STARTING );

				if(        0 != (GAME_B_PRESSED & getKeyStates()) ) {
					wallpaper_flag = 1;
//				} else if( 0 != (GAME_C_PRESSED & getKeyStates()) ) {
//					wallpaper_flag = 2;
				} else if( 0 != (GAME_D_PRESSED & getKeyStates()) ) {
					wallpaper_flag = 3;
				} else {
					wallpaper_flag = 0;
				}
			} else if( KEY_STAR == keyCode ) {
				applet myapp = applet.getInstance();
				myapp.webAccess();
			} else if( KEY_NUM0 == keyCode ) {
			}
			break;
		}

		case STAGE_GAME:
		{
			
			if( FIRE == getGameAction( keyCode ) ) {
				if( true == applet.isPaused ) {
					applet.isPaused = false;
					bgmStart();
				} else {
					bullets.add(ship.getx(), ship.gety(), ship.dir);
				}
			} else if( -7 == keyCode || -6 == keyCode ) {
				// SOFT1 or SOFT2 ꂽ烁j[\邽߃|[YB
				applet.isPaused = true;
				bgmStop();

			} else if( -8 == keyCode ) {
				// CLRL[
				applet.isPaused = !applet.isPaused;

				if( applet.isPaused ) {
					bgmStop();
				} else {
					bgmStart();
				}

			} else if( DOWN == getGameAction( keyCode ) ) {
				// ~TC
				bullets.add(ship.getx(), ship.gety(), ship.dir + 180);

			} else if( KEY_POUND == keyCode ) {
				// L[̓^Cgʂ֖߂
				if( applet.isPaused ) {
					stageChange( STAGE_TITLE );
				}
			}
			
			break;
		}
		
		case STAGE_GAMEOVER:
		{
			if( FIRE == getGameAction( keyCode ) ) {
				if( smokes.isEmpty() ){
					// FIREL[̘AłŃ^CgɈڍsȂ悤ɔ_ȂĂ
					stageChange( STAGE_TITLE );
				}
			} else if( -8 == keyCode || KEY_POUND == keyCode ) {
				// CLRL[#L[Ń^Cg
				stageChange( STAGE_TITLE );
			} else if( KEY_STAR == keyCode ) {
				// nCXRAo^(Web)
				applet myapp = applet.getInstance();
				myapp.webAccess();
			}
			break;
		}

		default:
			break;
		}
				
	}
	
	//* -------------------------------------------------------- */
	/**
	XbhC
	*/
	public void run() {
		long lBeforeTime, lDiffTime = 0;

		try {

			while(applet.bThreadLoop) {
				lBeforeTime = System.currentTimeMillis();
				
				flip1sec = ( 0 == (lBeforeTime / 1000) % 2 );	// 1sec tbv
	
				if( false == applet.isPaused ) {
					// L[͏̉P
					Thread.sleep(10);
	
					// ʏ
					paintBG();
	
					//* -------------------------------------------------
					// s
					//* -------------------------------------------------
					switch( stage ) {
	
						case STAGE_TITLE:
							Title(lDiffTime);
							break;
	
						case STAGE_STARTING:
							Starting(lDiffTime);
							break;
						case STAGE_GAME:
						case STAGE_GAMEOVER:
							Game(lDiffTime);
							break;
	
						default:
							break;
					}
					
				} else {
					drawStringBuffer( g, strGamePaused, 8, 8 );
					drawStringBuffer( g, strGameToExit, 3, 10 );
					// PauseCPUጸ
					Thread.sleep(100);
				}
				// `
				flushGraphics();				
				
				lDiffTime = System.currentTimeMillis() - lBeforeTime;
				if( lDiffTime > MAX_THREAD_INTERVAL ) {
					lDiffTime = MAX_THREAD_INTERVAL;
				}
				lStageLifeTime += lDiffTime;
			}
	
			keyThread.join();

		} catch(Exception e) {
			g.setColor( 255, 255, 255 );
			g.drawString( "Thread exception:"+e.toString(), 0, 0, Graphics.LEFT|Graphics.TOP);
			flushGraphics();
		}

		keyThread = null;
		keyInput = null;
	}

	//* -------------------------------------------------------- */
	/**
	wi`
	*/
	public void paintBG() {
		
		if( 0 == wallpaper_flag ) {
		
			if( score < 50 ) {
				for ( int yy = 0; yy < getHeight(); yy += applet.imgWallPaper.getHeight() ) {
					for( int xx = 0; xx < getWidth(); xx += applet.imgWallPaper.getWidth() ) {
						g.drawImage( applet.imgWallPaper, xx, yy, g.LEFT|g.TOP );
					}
				}
			} else if( score < 100 ) {
				g.drawImage( applet.imgMucha1, applet.OFFSET_DX, applet.OFFSET_DY, g.LEFT|g.TOP );
			} else {
				g.drawImage( applet.imgMucha3, applet.OFFSET_DX, applet.OFFSET_DY, g.LEFT|g.TOP );
			}
		} else if( 1 == wallpaper_flag ) {
			g.drawImage( applet.imgMucha1, applet.OFFSET_DX, applet.OFFSET_DY, g.LEFT|g.TOP );
		} else if( 2 == wallpaper_flag ) {
//			g.drawImage( applet.imgMucha2, applet.OFFSET_DX, applet.OFFSET_DY, g.LEFT|g.TOP );
		} else {
			g.drawImage( applet.imgMucha3, applet.OFFSET_DX, applet.OFFSET_DY, g.LEFT|g.TOP );
		}

	}
	
	//* -------------------------------------------------------- */
	/**
	MƏS̕`
	*/
	public void paintPenEraser() {
		// y̕`
		g.drawImage( applet.imgPen, getWidth() - applet.imgPen.getWidth()
				, getHeight() - applet.imgPen.getHeight(), g.LEFT|g.TOP );
		// S̕`
		g.drawImage( applet.imgEraser,  applet.OFFSET_DX, applet.OFFSET_DY, g.LEFT|g.TOP );
		
	}

	//* -------------------------------------------------------- */
	/**
	p[Q[W`(ݖgp)
	*/
	public void paintPower() {
		int dx = (applet.SCREEN_DX * ship.power) / ship.MAX_POWER;
		ship.setColorByShipPower( g );
		g.fillRect( applet.OFFSET_DX, applet.OFFSET_DY - 4, dx, 4 );
	}

	//* -------------------------------------------------------- */
	/**
	_`
	*/
	public void paintSocre() {
		if( score < hiscore || flip1sec ) {
			drawStringBuffer( g, strTitleHowHiScore, 10, 0 );
		} else {
		}
		draw4Int( hiscore, 12, 0 );
		draw4Int( score, 20, 0 );
	}

	//* -------------------------------------------------------- */
	/**
	^Cg`
	@param	lDiffTime	
	*/
	public void Title(long lDiffTime) {
		// MS̕`
		paintPenEraser();
		// _̕`
		paintSocre();

		debs.proceed( lDiffTime );
		ship.proceed( lDiffTime );
		debs.paint(g);
		ship.paint(g);
		
		title.paint(g, lDiffTime);

		drawStringBuffer(g, strTitleSpace, 6, 3);
		drawStringBuffer(g, strTitleCRilassaru, 3, 12);
		drawStringBuffer( g, strWebAccess, 1, 14 );
	}
	
	//* -------------------------------------------------------- */
	/**
	Q[Jnʕ`
	@param	lDiffTime	
	*/
	public void Starting(long lDiffTime) {
		int targetdir = ((int)lStageLifeTime % 360 ) / BaseObj.DGREE_RESOLUSION;
		int xx = getWidth() - applet.imgPen.getWidth();
		int yy = getHeight() - applet.imgPen.getHeight();

		if( lStageLifeTime > 500 ) {
			// Clip̈̐ݒ
			g.translate( applet.OFFSET_DX - g.getTranslateX(), applet.OFFSET_DY - g.getTranslateY() );
			ship.paint( g );
			// Clip̈̏C
			g.translate( -g.getTranslateX(), -g.getTranslateY() );
		}

		xx += (BaseObj.COS[targetdir]/10);
		yy += ((int)lStageLifeTime/100);

		// y̕`
		g.drawImage( applet.imgPen, xx, yy, g.LEFT|g.TOP );

		// S̕`
		g.drawImage( applet.imgEraser,  applet.OFFSET_DX, applet.OFFSET_DY, g.LEFT|g.TOP );

		drawStringBuffer( g, strTitleGameStart, 7, 8 );
	
		if( lStageLifeTime > 1000 ) {
			stageChange( STAGE_GAME );
		}
	}

	//* -------------------------------------------------------- */
	/**
	Q[ʕ`
	@param	lDiffTime	
	*/
	public void Game(long lDiffTime) {
		// MS̕`
		paintPenEraser();

		// IuWFNg̐is
		debs.proceed( lDiffTime );
		bullets.proceed( lDiffTime );
		ship.proceed( lDiffTime );
		smokes.proceed( lDiffTime );
		

		if( stage == STAGE_GAME ) {
			// Go^C}[
			debsinterval -= lDiffTime;
			if( debsinterval < 0 ) {

				debsinterval = DEBS_INTERVAL - (score * 50);	// oԊuĂ
				if( debsinterval < 2000 ) {
					debsinterval = 2000;
				}
				// XRAɉՓxݒ
				if( score < 5 ) {
					debs.add(1);
				} else if( score < 10 ) {
					debs.add(java.lang.Math.abs(applet.rand.nextInt() % 3) + 1);	// 1.2.3
				} else if( score < 15 ) {
					debs.add(java.lang.Math.abs(applet.rand.nextInt() % 4) + 2);	// 2.3.4.5
				} else if( score < 20 ) {
					debs.add(java.lang.Math.abs(applet.rand.nextInt() % 5) + 2);	// 2.3.4.5.6
				} else if( score < 25 ) {
					debs.add(java.lang.Math.abs(applet.rand.nextInt() % 7) + 1);	// 1.2.3.4.5.6.7
				} else if( score < 75 ) {
					debs.add(java.lang.Math.abs(applet.rand.nextInt() % 7) + 1);	// 1.2.3.4.5.6.7
				} else if( score < 100 ) {
					debs.add(java.lang.Math.abs(applet.rand.nextInt() % 7) + 1);	// 1.2.3.4.5.6.7
					debs.add(java.lang.Math.abs(applet.rand.nextInt() % 7) + 1);	// 1.2.3.4.5.6.7
				} else if( score < 150 ) {
					debs.add(java.lang.Math.abs(applet.rand.nextInt() % 7) + 1);	// 1.2.3.4.5.6.7
					debs.add(6);
					debs.add(4);
				} else {
					debs.add(java.lang.Math.abs(applet.rand.nextInt() % 7) + 1);	// 1.2.3.4.5.6.7
					debs.add(java.lang.Math.abs(applet.rand.nextInt() % 7) + 1);	// 1.2.3.4.5.6.7
					debs.add(java.lang.Math.abs(applet.rand.nextInt() % 7) + 1);	// 1.2.3.4.5.6.7
					debs.add(java.lang.Math.abs(applet.rand.nextInt() % 7) + 1);	// 1.2.3.4.5.6.7
				}
			}
	
			// Փ˔
			int score_add = debs.hittest( bullets );
			
			if( score_add > 0 ) {
				// U
				if( 0 != applet.viblation ) {
					applet.getInstance().startVib();
				}
				
				score += score_add;
	
				if( 0 != score_add && debs.isEmpty() ) {
					// GȂȂƁAɎ̓Go
					debsinterval = 1000;
				}
				
				if( hiscore < score ) {
					hiscore = score;
				}
			}

			if( (true == debs.hittest( ship )) || ( true == bullets.hittest( ship ) ) ) {
				
				smokes.addRed( ship.getx(), ship.gety() );
	
				if( 0 >= ship.reducePower( 100 ) ) {
					stageChange( STAGE_GAMEOVER );
					ship.state = BaseObj.STATE_NON_ACTIVE;
				}
			}
		}

		// Clip̈̐ݒ
		g.setClip( applet.OFFSET_DX, applet.OFFSET_DY, applet.SCREEN_DX, applet.SCREEN_DY );
		g.translate( applet.OFFSET_DX - g.getTranslateX(), applet.OFFSET_DY - g.getTranslateY() );

		// IuWFNg̕`
		smokes.paint(g);
		debs.paint(g);
		bullets.paint(g);
		ship.paint(g);


		// Clip̈̏C
		g.translate( -g.getTranslateX(), -g.getTranslateY() );
		g.setClip( 0, 0, getWidth(), getHeight() );


		// g`
		g.setColor( 0, 0, 0 );
		g.drawRect( applet.OFFSET_DX, applet.OFFSET_DY, applet.SCREEN_DX-1, applet.SCREEN_DY-1 );


		// XRA\
		paintSocre();
		
		if( stage == STAGE_GAMEOVER ) {
			if( flip1sec ) {
				drawStringBuffer( g, strGameOver, 8, 8 );
			}
			drawStringBuffer( g, strWebAccess, 1, 12 );
		}

	}
	
	//* -------------------------------------------------------- */
	/**
	`
	@param	g		`Ώ
	@param	istr	`敶
	@param	ix		`JnXʒu
	@param	iy		`JnYʒu
	*/
	public void drawStringBuffer( Graphics g, String istr, int ix, int iy ) {
		char cc;

		try{
			for( int ii = 0; ii < istr.length(); ii++ ) {
				cc = istr.charAt( ii ) ;

				applet.sprFont16.setFrame( (int)cc-32 );
				applet.sprFont16.setPosition( (ix+ii) * 10, iy * 16 );
				applet.sprFont16.paint( g );
			}
		}catch( Exception e ){
		}
	}

	//* -------------------------------------------------------- */
	/**
	4̐l`
	@param	in		`搔l
	@param	ix		`JnXʒu
	@param	iy		`JnYʒu
	*/
	public void draw4Int( int in, int ix, int iy ) {
		int index;
		try {
			for( int ii = 3; ii >= 0; ii-- ) {
				index = in % 10;
				applet.sprFont16.setFrame( index+16 );
				applet.sprFont16.setPosition( (ix+ii) * 10, iy * 16 );
				applet.sprFont16.paint( g );
				in /= 10;
			}
		} catch( Exception e ) {
			System.out.println(e.toString());
		}
	}
	
	//* -------------------------------------------------------- */
	/**
	Xe[WύX
	݂̃Xe[Ww肳ꂽXe[W֑J
	@param		istage	̃Xe[W
	*/
	public void stageChange(int istage) {
		lStageLifeTime = 0;
		stage = istage;
		
		if( STAGE_TITLE == stage ) {
			setFullScreenMode(false);
		} else {
			setFullScreenMode(true);
		}
		switch( istage ) {
			case STAGE_TITLE:
			{
				applet.isPaused = false;
				bgmStop();
				ship.init(10, 10);
				debs.init();
				debs.add( Deb.TYPE_D );
				debs.add( Deb.TYPE_E );
				debs.add( Deb.TYPE_F );
				break;
			}
			case STAGE_STARTING:
			{
				applet.isPaused = false;
				System.gc();
				wallpaper_flag = 0;
				score = 0;
				int xx = getWidth() - applet.imgPen.getWidth() - applet.OFFSET_DX;
				int yy = getHeight() - applet.imgPen.getHeight() - applet.OFFSET_DY;
				ship.init(xx, yy);

				try {
					vc.setLevel(applet.volume);
					sndBGM.setMediaTime(0);
					bgmStart();
				} catch( Exception e ) {}
				break;
			}
			
			case STAGE_GAME:
			{
				debs.init();
				bullets.init();
				smokes.init();
				score = 0;
				debsinterval = 0;
				break;
			}
			
			case STAGE_GAMEOVER:
			{
				bgmStop();
				break;
			}
			default:
				break;

		}
	}
	
	//* -------------------------------------------------------- */
	/**
	Q[|[Y
	*/
	void gamePause() {
		if( STAGE_GAME == stage ) {
			applet.isPaused = true;
			bgmStop();
		}
	}

	//* -------------------------------------------------------- */
	/**
	Q[ĊJ
	*/
	void gameResume() {
		if( STAGE_STARTING == stage || STAGE_GAME == stage ) {
			applet.isPaused = true;
		}
	}

	//* -------------------------------------------------------- */
	/**
	BGMJn
	*/
	private void bgmStart() {
		vc.setLevel( applet.volume );
		try {
			sndBGM.start();
		} catch( Exception e ) {}
	}

	//* -------------------------------------------------------- */
	/**
	BGMI
	*/
	private void bgmStop() {
		try {
			sndBGM.stop();
		} catch( Exception e ) {}
	}
}
